Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions

# NurbsCurveEvaluator Class Reference

This class is an abstraction for evaluating NURBS curves. More...

Inheritance diagram for NurbsCurveEvaluator:

List of all members.

## Public Member Functions
| NurbsCurveEvaluator ()
NurbsCurveResult | evaluate (NodePath const rel_to)
| Returns a NurbsCurveResult object that represents the result of applying the knots to all of the current values of the vertices, transformed into the indicated coordinate space.
NurbsCurveResult | evaluate ()
| Returns a NurbsCurveResult object that represents the result of applying the knots to all of the current values of the vertices, transformed into the indicated coordinate space.
NurbsCurveResult | evaluate (NodePath const rel_to, Mat4 const mat)
| Returns a NurbsCurveResult object that represents the result of applying the knots to all of the current values of the vertices, transformed into the indicated coordinate space, and then further transformed by the indicated matrix.
float | getExtendedVertex (int i, int d)
| Returns an n-dimensional vertex value.
float | getKnot (int i)
| Returns the value of the nth knot.
list | getKnots ()
int | getNumKnots ()
| Returns the number of knot values in the curve.
int | getNumSegments ()
| Returns the number of piecewise continuous segments in the curve.
int | getNumVertices ()
| Returns the number of control vertices in the curve.
int | getOrder ()
| Returns the order of the curve as set by a previous call to set_order().
VBase4 const | getVertex (int i)
| Returns the nth control vertex of the curve, relative to its indicated coordinate space.
VBase4 | getVertex (int i, NodePath const rel_to)
| Returns the nth control vertex of the curve, relative to the given coordinate space.
NodePath | getVertexSpace (int i, NodePath const rel_to)
| Returns the coordinate space of the nth control vertex of the curve, expressed as a NodePath.
list | getVertices ()
| normalizeKnots ()
| Normalizes the knot sequence so that the parametric range of the curve is 0 .
| output (ostream out)
| reset (int num_vertices)
| Resets all the vertices and knots to their default values, and sets the curve up with the indicated number of vertices.
| setExtendedVertex (int i, int d, float value)
| Sets an n-dimensional vertex value.
| setKnot (int i, float knot)
| Sets the value of the nth knot.
| setOrder (int order)
| Sets the order of the curve.
| setVertex (int i, VBase3 const vertex, float weight)
| Sets the nth control vertex of the curve.
| setVertex (int i, VBase4 const vertex)
| Sets the nth control vertex of the curve, as a vertex in 4-d homogeneous space.
| setVertex (int i, VBase3 const vertex)
| Sets the nth control vertex of the curve.
| setVertexSpace (int i, string space)
| Sets the coordinate space of the nth control vertex.
| setVertexSpace (int i, NodePath const space)
| Sets the coordinate space of the nth control vertex.

## Detailed Description

This class is an abstraction for evaluating NURBS curves.

It accepts an array of vertices, each of which may be in a different coordinate space (as defined by a NodePath), as well as an optional knot vector.

This is not related to NurbsCurve, CubicCurveseg or any of the ParametricCurve-derived objects in this module. It is a completely parallel implementation of NURBS curves, and will probably eventually replace the whole ParametricCurve class hierarchy.

## Constructor & Destructor Documentation

NurbsCurveEvaluator | ( |  | ) |

## Member Function Documentation

NurbsCurveResult evaluate | ( | NodePath const | rel_to | ) |

Returns a NurbsCurveResult object that represents the result of applying the knots to all of the current values of the vertices, transformed into the indicated coordinate space.

NurbsCurveResult evaluate | ( |  | ) |

Returns a NurbsCurveResult object that represents the result of applying the knots to all of the current values of the vertices, transformed into the indicated coordinate space.

NurbsCurveResult evaluate | ( | NodePath const | rel_to,
|  | Mat4 const | mat
| ) |  |

Returns a NurbsCurveResult object that represents the result of applying the knots to all of the current values of the vertices, transformed into the indicated coordinate space, and then further transformed by the indicated matrix.

float getExtendedVertex | ( | int | i,
|  | int | d
| ) |  |

Returns an n-dimensional vertex value.

See set_extended_vertex(). This returns the value set for the indicated dimension, or 0.0 if nothing has been set.

float getKnot | ( | int | i | ) |

Returns the value of the nth knot.

list getKnots | ( |  | ) |

int getNumKnots | ( |  | ) |

Returns the number of knot values in the curve.

This is based on the number of vertices and the order.

int getNumSegments | ( |  | ) |

Returns the number of piecewise continuous segments in the curve.

This is based on the knot vector.

int getNumVertices | ( |  | ) |

Returns the number of control vertices in the curve.

This is the number passed to the last call to reset().

int getOrder | ( |  | ) |

Returns the order of the curve as set by a previous call to set_order().

VBase4 const getVertex | ( | int | i | ) |

Returns the nth control vertex of the curve, relative to its indicated coordinate space.

VBase4 getVertex | ( | int | i,
|  | NodePath const | rel_to
| ) |  |

Returns the nth control vertex of the curve, relative to the given coordinate space.

NodePath getVertexSpace | ( | int | i,
|  | NodePath const | rel_to
| ) |  |

Returns the coordinate space of the nth control vertex of the curve, expressed as a NodePath.

list getVertices | ( |  | ) |

normalizeKnots | ( |  | ) |

Normalizes the knot sequence so that the parametric range of the curve is 0 .

. 1.

output | ( | ostream | out | ) |

reset | ( | int | num_vertices | ) |

Resets all the vertices and knots to their default values, and sets the curve up with the indicated number of vertices.

You must then call set_vertex() repeatedly to fill in all of the vertex values appropriately.

setExtendedVertex | ( | int | i,
|  | int | d,
|  | float | value
| ) |  |

Sets an n-dimensional vertex value.

This allows definition of a NURBS surface or curve in a sparse n-dimensional space, typically used for associating additional properties (like color or joint membership) with each vertex of a surface.

The value d is an arbitrary integer value and specifies the dimension of question for this particular vertex. Any number of dimensions may be specified, and they need not be consecutive. If a value for a given dimension is not specified, is it implicitly 0.0.

The value is implicitly scaled by the homogenous weight value--that is, the fourth component of the value passed to set_vertex(). This means the ordinary vertex must be set first, before the extended vertices can be set.

setKnot | ( | int | i,
|  | float | knot
| ) |  |

Sets the value of the nth knot.

Each knot value should be greater than or equal to the preceding value. If no knot values are set, a default knot vector is supplied.

setOrder | ( | int | order | ) |

Sets the order of the curve.

This resets the knot vector to the default knot vector for the number of vertices.

The order must be 1, 2, 3, or 4, and the value is one more than the degree of the curve.

setVertex | ( | int | i,
|  | VBase4 const | vertex
| ) |  |

Sets the nth control vertex of the curve, as a vertex in 4-d homogeneous space.

In this form, the first three components of the vertex should already have been scaled by the fourth component, which is the homogeneous weight.

setVertex | ( | int | i,
|  | VBase3 const | vertex
| ) |  |

Sets the nth control vertex of the curve.

This flavor sets the vertex as a 3-d coordinate and a weight; the 3-d coordinate values are implicitly scaled up by the weight factor.

setVertex | ( | int | i,
|  | VBase3 const | vertex,
|  | float | weight
| ) |  |

Sets the nth control vertex of the curve.

This flavor sets the vertex as a 3-d coordinate and a weight; the 3-d coordinate values are implicitly scaled up by the weight factor.

setVertexSpace | ( | int | i,
|  | NodePath const | space
| ) |  |

Sets the coordinate space of the nth control vertex.

If this is not specified, or is set to an empty NodePath, the nth control vertex is deemed to be in the coordinate space passed to evaluate().

This specifies the space as a fixed NodePath, which is always the same NodePath. Also see setting the space as a path string, which can specify a different NodePath for different instances of the curve.

setVertexSpace | ( | int | i,
|  | string | space
| ) |  |

Sets the coordinate space of the nth control vertex.

If this is not specified, or is set to an empty string, the nth control vertex is deemed to be in the coordinate space passed to evaluate().

This specifies the space as a string, which describes the path to find the node relative to the rel_to NodePath when the curve is evaluated.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties